VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Hide process Example"
   ClientHeight    =   4065
   ClientLeft      =   45
   ClientTop       =   405
   ClientWidth     =   3885
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   4065
   ScaleWidth      =   3885
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdAbout 
      Caption         =   "About"
      Height          =   495
      Left            =   120
      TabIndex        =   14
      Top             =   3480
      Width           =   1695
   End
   Begin VB.CommandButton cmdHideMe 
      Caption         =   "Hide My Process"
      Height          =   495
      Left            =   2040
      TabIndex        =   13
      Top             =   3480
      Width           =   1695
   End
   Begin VB.Timer tmrTrack 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   960
      Top             =   2280
   End
   Begin VB.TextBox txtHwnd 
      Appearance      =   0  'Flat
      Height          =   285
      Left            =   1560
      Locked          =   -1  'True
      TabIndex        =   7
      Top             =   1920
      Width           =   2055
   End
   Begin VB.Frame fmDetectProcess 
      Caption         =   "Detect Process"
      Height          =   1695
      Left            =   120
      TabIndex        =   5
      Top             =   1680
      Width           =   3615
      Begin VB.CommandButton cmdTrack 
         Caption         =   "Track"
         Height          =   375
         Left            =   240
         TabIndex        =   12
         Top             =   1200
         Width           =   975
      End
      Begin VB.CommandButton cmdHideDP 
         Caption         =   "Hide"
         Height          =   375
         Left            =   2520
         TabIndex        =   11
         Top             =   1200
         Width           =   975
      End
      Begin VB.TextBox txtPID 
         Appearance      =   0  'Flat
         Height          =   285
         Left            =   1440
         Locked          =   -1  'True
         TabIndex        =   10
         Top             =   720
         Width           =   2055
      End
      Begin VB.CommandButton cmdShowDP 
         Caption         =   "Show"
         Height          =   375
         Left            =   1440
         TabIndex        =   8
         Top             =   1200
         Width           =   975
      End
      Begin VB.Label Label2 
         AutoSize        =   -1  'True
         BackStyle       =   0  'Transparent
         Caption         =   "Process ID:"
         Height          =   195
         Index           =   1
         Left            =   240
         TabIndex        =   9
         Top             =   720
         Width           =   825
      End
      Begin VB.Label Label2 
         AutoSize        =   -1  'True
         BackStyle       =   0  'Transparent
         Caption         =   "Window:"
         Height          =   195
         Index           =   0
         Left            =   240
         TabIndex        =   6
         Top             =   360
         Width           =   630
      End
   End
   Begin VB.CommandButton cmdShowExe 
      Caption         =   "Show"
      Height          =   375
      Left            =   1320
      TabIndex        =   4
      Top             =   960
      Width           =   975
   End
   Begin VB.Frame fmHideProcByName 
      Caption         =   "Hide Process By Exe Name"
      Height          =   1455
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   3615
      Begin VB.CommandButton cmdGetPid 
         Caption         =   "get"
         Height          =   255
         Left            =   2880
         TabIndex        =   16
         Top             =   360
         Width           =   495
      End
      Begin VB.CommandButton cmdHideExe 
         Caption         =   "Hide"
         Height          =   375
         Left            =   2400
         TabIndex        =   3
         Top             =   840
         Width           =   975
      End
      Begin VB.TextBox txtExeName 
         Appearance      =   0  'Flat
         Height          =   285
         Left            =   1200
         TabIndex        =   2
         Text            =   "notepad.exe"
         Top             =   360
         Width           =   1575
      End
      Begin VB.Label lblPID 
         Alignment       =   2  'Center
         Caption         =   "0xFFFFFFFF"
         ForeColor       =   &H000000C0&
         Height          =   255
         Left            =   120
         TabIndex        =   15
         Top             =   960
         Width           =   975
      End
      Begin VB.Label Label1 
         AutoSize        =   -1  'True
         BackStyle       =   0  'Transparent
         Caption         =   "Exe Name:"
         Height          =   195
         Left            =   240
         TabIndex        =   1
         Top             =   360
         Width           =   780
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit


Private Proc        As ProcessSecurity


Private Type POINTAPI
        x As Long
        y As Long
End Type


Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Private Declare Function WindowFromPoint Lib "user32" (ByVal xPoint As Long, ByVal yPoint As Long) As Long
Private Declare Function GetWindowThreadProcessId Lib "user32" (ByVal hwnd As Long, lpdwProcessId As Long) As Long
Private Declare Function GetWindowTextLength Lib "user32" Alias "GetWindowTextLengthA" (ByVal hwnd As Long) As Long
Private Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hwnd As Long, ByVal lpString As String, ByVal cch As Long) As Long

Private Sub cmdAbout_Click()

    MsgBox "Created by: Islam Adel (aka [mE])" & vbCrLf & _
           "If you like it, please vote @ PSC", vbInformation, "About"

End Sub

Private Sub cmdGetPid_Click()
    
    Dim m_PId           As Long
    
    
    With lblPID
        If (Proc.ProcessInfo.GetProcessIdByName(txtExeName.Text, m_PId)) Then
            .ForeColor = &H8000&
            lblPID.Caption = "0x" & Hex8(m_PId)
        Else
            .ForeColor = &HC0&
            .Caption = "0xFFFFFFFF"
        End If
    End With
    
End Sub

Private Sub cmdHideDP_Click()
    
    Dim lHandle     As Long
    
    
    lHandle = CLng(Val(fmDetectProcess.Tag))
    If (lHandle <> 0) Then
        MsgBox "A process is already hidden. Please show it first!", vbExclamation, ""
        Exit Sub
    End If

    lHandle = CLng(Val(tmrTrack.Tag))
    If (lHandle = 0) Then
        MsgBox "Please specify a process first", vbExclamation, ""
        Exit Sub
    End If
    
    If (Proc.Process.HideProcess(lHandle, lHandle)) Then
    
        MsgBox "Process is now hidden!", vbInformation, ""
        fmDetectProcess.Tag = CLng(lHandle)
        
    Else
        
        MsgBox "Process could not be hidden!" & vbCrLf & _
               "Error: " & Proc.Process.GetLastErrorMessage(), vbExclamation, ""
        
    End If
    
End Sub

Private Sub cmdHideExe_Click()
    
    Dim lHandle     As Long
    
    
    If (lblPID.Caption = "0xFFFFFFFF") Then
        MsgBox "Please specify a process first", vbExclamation, ""
        Exit Sub
    End If
    
    lHandle = CLng(Val(fmHideProcByName.Tag))
    If (lHandle <> 0) Then
        MsgBox "A process is already hidden. Please show it first!", vbExclamation, ""
        Exit Sub
    End If
    
    lHandle = CLng(Val("&H" & Mid(lblPID.Caption, 3)))
    
    If (Proc.Process.HideProcess(lHandle, lHandle)) Then
    
        MsgBox "Process is now hidden!", vbInformation, ""
        fmHideProcByName.Tag = CLng(lHandle)
        
    Else
        
        MsgBox "Process could not be hidden!" & vbCrLf & _
               "Error: " & Proc.Process.GetLastErrorMessage(), vbExclamation, ""
        
    End If
    
End Sub

Private Sub cmdHideMe_Click()

    Dim lHandle             As Long
    
    
    lHandle = CLng(Val(cmdHideMe.Tag))
    
    If (lHandle = 0) Then
        
        If (Proc.Process.HideProcess(lHandle, Proc.ProcessInfo.GetMyProcessId())) Then
        
            MsgBox "Process is now hidden!", vbInformation, ""
            cmdHideMe.Tag = lHandle
            cmdHideMe.Caption = "Show My Process"
            
        Else
            MsgBox "Process could not be hidden!" & vbCrLf & _
                   "Error: " & Proc.Process.GetLastErrorMessage(), vbExclamation, ""
        End If
        
    Else
    
        If (Proc.Process.ShowProcess(lHandle)) Then
        
            MsgBox "Process is now shown!", vbInformation, ""
            cmdHideMe.Tag = CLng(0)
            cmdHideMe.Caption = "Hide My Process"
            
        Else
            MsgBox "Process could not be shown!" & vbCrLf & _
                   "Error: " & Proc.Process.GetLastErrorMessage(), vbExclamation, ""
        End If
    
    End If
    
End Sub


Private Sub cmdShowDP_Click()

    Dim lHandle     As Long
    
    
    lHandle = CLng(Val(fmDetectProcess.Tag))
    If (lHandle = 0) Then
        MsgBox "A process cannot be shown before it's been hid.", vbExclamation, ""
        Exit Sub
    End If
    
    If (Proc.Process.ShowProcess(lHandle)) Then
        MsgBox "Process is now shown!", vbInformation, ""
        fmDetectProcess.Tag = CLng(0)
    Else
        MsgBox "Process could not be shown (terminated?)!", vbExclamation, ""
    End If

End Sub


Private Sub cmdShowExe_Click()

    Dim lHandle     As Long
    
    
    lHandle = CLng(Val(fmHideProcByName.Tag))
    If (lHandle = 0) Then
        MsgBox "A process cannot be shown before it's been hid.", vbExclamation, ""
        Exit Sub
    End If
    
    If (Proc.Process.ShowProcess(lHandle)) Then
        MsgBox "Process is now shown!", vbInformation, ""
        fmHideProcByName.Tag = CLng(0)
    Else
        MsgBox "Process could not be shown (terminated?)!", vbExclamation, ""
    End If

End Sub


Private Sub cmdTrack_Click()
    
    Dim lHandle     As Long
    
    
    lHandle = CLng(Val(fmDetectProcess.Tag))
    If (lHandle <> 0) Then
        MsgBox "A process is already hidden. Please show it first!", vbExclamation, ""
        Exit Sub
    End If
    
    Select Case (cmdTrack.Tag)
    
        Case False
            cmdTrack.Caption = "Stop"
            
        Case True
            cmdTrack.Caption = "Track"
            tmrTrack.Tag = CLng(txtPID.Text)
            
    End Select
    
    cmdTrack.Tag = Not CBool(cmdTrack.Tag)
    tmrTrack.Enabled = CBool(cmdTrack.Tag)
    
End Sub

Private Sub Form_Load()
    
    cmdTrack.Tag = CBool(False)
    fmDetectProcess.Tag = CLng(0)
    fmHideProcByName.Tag = CLng(0)
    tmrTrack.Tag = CLng(0)
    cmdHideMe.Tag = CLng(0)
    
    Set Proc = New ProcessSecurity
    
End Sub

Private Sub Form_Unload(Cancel As Integer)
    
    ShowAll
    Set Proc = Nothing
    
End Sub


Private Sub tmrTrack_Timer()
    
    Dim lHwnd       As Long, _
        lPId        As Long
    
    
    lHwnd = GetWindowUnderCursor(lPId)
    txtHwnd.Text = """" & WindowText(lHwnd) & """" & " (0x" & Hex8(lHwnd) & ")"
    txtHwnd.SelLength = Len(txtHwnd.Text)
    txtPID.Text = lPId
    
End Sub


Private Sub ShowAll()
    
    Dim lHandle         As Long
    
    
    lHandle = CLng(Val(fmDetectProcess.Tag))
    If (lHandle <> 0) Then
        Call Proc.Process.ShowProcess(lHandle)
    End If
    
    lHandle = CLng(Val(fmHideProcByName.Tag))
    If (lHandle <> 0) Then
        Call Proc.Process.ShowProcess(lHandle)
    End If
    
    lHandle = CLng(Val(cmdHideMe.Tag))
    If (lHandle <> 0) Then
        Call Proc.Process.ShowProcess(lHandle)
    End If
    
End Sub

Private Function GetWindowUnderCursor(ByRef m_ProcessID As Long) As Long
    
    Dim lHwnd       As Long, _
        lPos        As POINTAPI
    
    
    GetCursorPos lPos
    lHwnd = WindowFromPoint(lPos.x, lPos.y)
    Call GetWindowThreadProcessId(lHwnd, m_ProcessID)
    
    GetWindowUnderCursor = lHwnd
    
End Function

Private Function WindowText(ByVal lHwnd As Long) As String
    
    WindowText = Space(GetWindowTextLength(lHwnd))
    Call GetWindowText(lHwnd, WindowText, Len(WindowText) + 1)
    
End Function

Private Function Hex8(ByVal lLong As Long) As String

    Hex8 = Hex(lLong)
    Hex8 = String(8 - Len(Hex8), "0") & Hex8
    
End Function
